﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsFormsApplication1
{

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void get_status_Click(object sender, EventArgs e)
        {
            byte[] read_buf = new byte[10465];
            string str1 = "2D37";
            string str2 = "560A";
            byte[] vid = System.Text.Encoding.ASCII.GetBytes(str1);
            byte[] pid = System.Text.Encoding.ASCII.GetBytes(str2);
            int fs = print.B4OpenUsb(vid, pid);
            ushort fs1;
            fs1 = (ushort)fs;
            string write = "\x1B!?";
            byte[] write1 = System.Text.Encoding.ASCII.GetBytes(write);
           int a=6;
           ushort b;
           b =(ushort)a;
           print.B4WriteUsb(fs1, write1, b);
            int num1 = print.B4ReadUsb(fs1, read_buf, 10465);
            print.B4CloseUsb(fs1);
            if (read_buf[0] == 0x00)
            {
                StringBuilder str = new StringBuilder("Stand by");
                textBox1.Text = str.ToString();

            }
            else if (read_buf[0] == '\x1')
            {
                StringBuilder str = new StringBuilder("Cover opened");
                textBox1.Text = str.ToString();
            }
            else if (read_buf[0] == '\x2')
            {
                StringBuilder str = new StringBuilder("Paper jam");
                textBox1.Text = str.ToString();
            }
             if (read_buf[0] == '\x3')
            {
                StringBuilder str = new StringBuilder("Paper jam");
                textBox1.Text = str.ToString();


            }
            else if (read_buf[0] == '\x4')
            {
                StringBuilder str = new StringBuilder("Paper end");
                textBox1.Text = str.ToString();


            }
            else if (read_buf[0] == '\x5')
            {
                StringBuilder str = new StringBuilder("Paper end");
                textBox1.Text = str.ToString();
            }
             else if (read_buf[0] == '\x8')
            {
                StringBuilder str = new StringBuilder("Ribbon end");
                textBox1.Text = str.ToString();

            }
            else if (read_buf[0] == '\x9')
            {
                StringBuilder str = new StringBuilder("Ribbon end");
                textBox1.Text = str.ToString();
            }
            else if (read_buf[0] == '\xA')
            {
                StringBuilder str = new StringBuilder("Ribbon end");
                textBox1.Text = str.ToString();
            }
             else if (read_buf[0] == '\xB')
            {
                StringBuilder str = new StringBuilder("Ribbon end");
                textBox1.Text = str.ToString();
            }
            else if (read_buf[0] == '\xC')
            {
                StringBuilder str = new StringBuilder("Paper end and Ribbon end");
                textBox1.Text = str.ToString();
            }
             else if (read_buf[0] == '\xD')
            {
                StringBuilder str = new StringBuilder("Paper end and Ribbon end");
                textBox1.Text = str.ToString();
            }
             else if (read_buf[0] == '\x10')
            {
                StringBuilder str = new StringBuilder("Pause");
                textBox1.Text = str.ToString();
            }
            else if (read_buf[0] == '\x20')
            {
                StringBuilder str = new StringBuilder("Paper end");
                textBox1.Text = str.ToString();
            }
            else if (read_buf[0] == '\x80')
            {
                StringBuilder str = new StringBuilder("Unknown error");
                textBox1.Text = str.ToString();
            }

        }
        private void button1_Click(object sender, EventArgs e)
        {
             int[] write_buf = new int[10465];
            int[] read_buf = new int[10465];
            string str1 = "2D37";
            string str2 = "7693";
            byte[] vid = System.Text.Encoding.ASCII.GetBytes(str1);
            byte[] pid = System.Text.Encoding.ASCII.GetBytes(str2);
            int fs = print.B4OpenUsb(vid, pid);
            ushort fs1;
            fs1 = (ushort)fs;
            string write = "SELFTEST\xD\xA";
            byte[] write1 = System.Text.Encoding.ASCII.GetBytes(write);
            print.B4WriteUsb(fs1, write1, (ushort)14);
            print.B4CloseUsb(fs1);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            int[] write_buf = new int[10465];
            int[] read_buf = new int[10465];
            string str1 = "2D84";
            string str2 = "B468";
            byte[] vid = System.Text.Encoding.ASCII.GetBytes(str1);
            byte[] pid = System.Text.Encoding.ASCII.GetBytes(str2);
            int fs = print.B4OpenUsb(vid, pid);
            ushort fs1;
            fs1 = (ushort)fs;
            string write = " CODEPAGE 437\r\nCLS\r\nTEXT 10,10,\"2\",0,2,2,\"Hello world\"\r\nPRINT 1\r\n";
            byte[] write1 = Encoding.GetEncoding("cp437").GetBytes(write);
            print.B4WriteUsb(fs1, write1, (ushort)write1.Length);
            print.B4CloseUsb(fs1);
        }
    }
}

class print
{
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4usbportwrite(byte[] VId, byte[] PId, uint iLen, byte[] Data);

    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4comportwrite(byte[] Com,
                                        uint BaudRate,
                                        byte Parity,
                                        byte ByteSize,
                                        byte fDtrControl,
                                        byte StopBits,
                                        uint iLen,
                                        byte[] Data);

    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4Netportwrite(uint addr, uint port, uint Timeout, uint iLen, byte[] Data);

    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4Lptportwrite(byte[] Name, uint iLen, byte[] Data);

    /*
    *Network function
    */
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern bool B4vInitNetSev();
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4ConnectNetPort(uint addr, uint port, uint Timeout);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4WriteToNetPort(UInt16 fs, byte[] SendBuf, UInt16 WriteSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4ReadFromNetPort(UInt16 fs, byte[] RecvBuf, UInt16 RecvBufSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern bool B4CloseNetPor(UInt16 fs);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern bool B4CloseNetServ();

    /*
    *USB interface function
    */
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4OpenUsb(byte[] vid, byte[] pid);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4WriteUsb(UInt16 fs, byte[] SendBuf, UInt16 SendBufSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4ReadUsb(UInt16 fs, byte[] ReadBuf, UInt16 ReadBufSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern bool B4CloseUsb(UInt16 fs);

    /*
    *Parallel interface function
    */
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4OpenLptW(byte[] Name);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4WriteLpt(UInt16 fs, byte[] SendBuf, UInt16 SendBufSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4ReadLpt(UInt16 fs, byte[] ReadBuf, UInt16 ReadBufSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern bool B4CloseLpt(UInt16 fs);
    /*
    *Serial interface function
    */
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4OpenComW(byte[] Com, uint BaudRate, Byte Parity, Byte ByteSize, Byte fDtrControl, Byte StopBits);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4ReadCom(UInt16 fs, byte[] ReadBuf, UInt16 SendBufSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern int B4WriteCom(UInt16 fs, byte[] SendBuf, UInt16 WriteSize);
    [DllImport("4barcode.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
    public static extern bool B4CloseCom(UInt16 fs);

}